//    Copyright 2013 Massimiliano Margonari, EnginSoft S.P.A.
// 
//    Licensed under the Apache License, Version 2.0 (the "License");
//    you may not use this file except in compliance with the License.
//    You may obtain a copy of the License at
// 
//        http://www.apache.org/licenses/LICENSE-2.0
// 
//    Unless required by applicable law or agreed to in writing, software
//    distributed under the License is distributed on an "AS IS" BASIS,
//    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//    See the License for the specific language governing permissions and
//    limitations under the License.




function [outUp, outDown]=box_whiskers(data)
//function [outUp, outDown]=box_whiskers(fig_id,data)

//Plot the box and whiskers
//data [np,nv]
//np = number of points
//nv = number of variables

[np,nv]=size(data);

extr_inf=min(data);
extr_sup=max(data);

extr_inf=extr_inf-0.1*(extr_sup-extr_inf);
extr_sup=extr_sup+0.1*(extr_sup-extr_inf);

//f=scf(fig_id);
plot2d(0,0,rect=[0,extr_inf,nv+1,extr_sup],axesflag=0);

//xtitle("box whiskers plot");

for i=1:nv
 
 extr_inf=min(data(:,i));
 extr_sup=max(data(:,i));
 
 m=mean(data(:,i));
 q=quart(data(:,i));
 iq=q(3)-q(1);
 
 //Find outliers
 //Lower
 out=find(data(:,i)<q(1)-1.5*iq);
 outDown=out;

 if (out<>[]) then
  plot(i*ones(length(out),1),data(out,i),'.r');
  v=min(data(find(data(:,i)>q(1)-1.5*iq),i));
  plot([i;i],[v; q(1)]);
  plot([i-1/8;i+1/8],[v; v]);
 else
  plot([i;i],[extr_inf; q(1)]);
  plot([i-1/8;i+1/8],[extr_inf; extr_inf]);
 end
 
 //Upper
 out=find(data(:,i)>q(3)+1.5*iq);
 outUp=out;
 
 if (out<>[]) then
  plot(i*ones(length(out),1),data(out,i),'.r');
  v=max(data(find(data(:,i)<q(3)+1.5*iq),i));
  plot([i;i],[v; q(3)]);
  plot([i-1/8;i+1/8],[v; v]);
 else
  plot([i;i],[extr_sup; q(3)]);
  plot([i-1/8;i+1/8],[extr_sup; extr_sup]);
 end 
 
 //Box
 xset("color",11)
 xpoly([1/8; 1/8; -1/8; -1/8]+i,[q(1); q(3); q(3); q(1)],'lines',1);
 xset("color",0)
 
 //Mean
 plot([i-1/4;i+1/4],[m; m]','r');
 
 //Mode
 plot([i-1/4;i+1/4],[q(2); q(2)],'g');
  
end

endfunction
