//    Copyright 2013 Massimiliano Margonari, EnginSoft S.P.A.
// 
//    Licensed under the Apache License, Version 2.0 (the "License");
//    you may not use this file except in compliance with the License.
//    You may obtain a copy of the License at
// 
//        http://www.apache.org/licenses/LICENSE-2.0
// 
//    Unless required by applicable law or agreed to in writing, software
//    distributed under the License is distributed on an "AS IS" BASIS,
//    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//    See the License for the specific language governing permissions and
//    limitations under the License.




function [c]=linear_correlation(x,y)

//Compute the linear correlation coefficient between two series of data
//x and y same length vectors

xm=mean(x);
ym=mean(y);

xs=sqrt(sum((x-xm).^2)/length(x));
ys=sqrt(sum((y-ym).^2)/length(y));

c=mean((x-xm).*(y-ym))/(xs*ys);

endfunction
