//    Copyright 2013 Massimiliano Margonari, Anna Bassi, EnginSoft S.P.A.
// 
//    Licensed under the Apache License, Version 2.0 (the "License");
//    you may not use this file except in compliance with the License.
//    You may obtain a copy of the License at
// 
//        http://www.apache.org/licenses/LICENSE-2.0
// 
//    Unless required by applicable law or agreed to in writing, software
//    distributed under the License is distributed on an "AS IS" BASIS,
//    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//    See the License for the specific language governing permissions and
//    limitations under the License.




function []=plot_parallel_chart(fig_id,data,index,labels)

//data [nd,nv]
//nd = number of designs
//nv = number of variables


[nd,nv]=size(data);

f=scf(fig_id);
plot2d(0,0,rect=[-0.1,-0.1,nv+1,1.1],axesflag=0);

x=linspace(1,nv,nv);
y=zeros(nd,nv);

extr_inf=min(data,'r');
extr_sup=max(data,'r');

for i=1:nd
 y(i,:)=(data(i,:)-extr_inf)./(extr_sup-extr_inf);
end

// isolating the "index" elements
yind = y(index,:);
y(index,:)=[];

// plot of the elements in light blue
plot2d(x',y');
f.children.children(1).children(:).foreground=12;
// plot of the "index" elements in red
plot2d(x',yind');
f.children.children(1).children(:).foreground=5;
f.children.children(1).children(:).thickness=2;

// draw vertical axes
x=[x; x];
y=zeros(2,nv);
y(2,:)=1;
for i=1:nv
plot2d(x(:,i),y(:,i))
end

// values on the vertical axes
for i=1:nv
 for j=1:9
  str=(extr_sup(1,i)-extr_inf(1,i))*j/10+extr_inf(1,i);
  xstring(x(1,i),y(1,i)+j/10,string(str));
 end
end

for i=1:nv
 xstring(x(1,i),y(1,i),string(extr_inf(1,i)));
 //f.children.children(1).font_size=3;
 xstring(x(2,i),y(2,i),string(extr_sup(1,i)));
 //f.children.children(1).font_size=3;
end

f.children.axes_visible=["off","off","off"];

// green circles on the extremes
r=0.03;
for i=1:nv
 xarc(i-r/2,r/2,r,r,0,360*64);
 f.children.children(1).fill_mode="on";
 f.children.children(1).background=15;
 //xstring(i-r/2,r/2,string(extr_inf(1,i)));
 xarc(i-r/2,1+r/2,r,r,0,360*64);
 f.children.children(1).fill_mode="on";
 f.children.children(1).background=18;
 //xstring(i-r/2,1+r/2,string(extr_sup(1,i)));
end

for i=1:nv
 xstring(i-r/2,r/2,string(extr_inf(1,i)),0,1);
// disp(f.children.children(1))
 f.children.children(1).font_size=3;
 f.children.children(1).fill_mode="on";
 xstring(i-r/2,1+r/2,string(extr_sup(1,i)),0,1);
 f.children.children(1).font_size=3;
 f.children.children(1).fill_mode="on";
end

// labels
for i = 1:2:nv
 xstring(i,-.05,labels(i),0,0);
 f.children.children(1).font_size=2;
 f.children.children(1).fill_mode="on";
end
for i = 2:2:nv
 xstring(i,1.06,labels(i),0,0);
 f.children.children(1).font_size=2;
 //f.children.children(1).fill_mode="on";
end
endfunction
